#define RANDOM_ONLY
#define NOCHECK
#define DISK_SIZES
#include "sort.h"
#include <memory/cache.h>

#include <sort/qsort.h>
#include <sort/funnel.h>
#include <sort/heap.h>
#include <sort/merge.h>

namespace {

template<class Storage, class T> void runSorts(Pointer<Storage, T> input, Pointer<Storage, T> expected, Pointer<Storage, T> buffer, size_t size, const char *name, bool runThreaded) {
	RUN(qsort);
	RUN(funnel);
	RUN(funnelHybrid);
	RUN(funnelFullHybrid);
	if (size <= 7707346) {
		RUN(heap);
	}
	RUN(mergeStack);
	if (size <= 52024589) {
		RUN(mergeFifo);
	}
	if (runThreaded) {
		RUN(qsortThreaded);
		RUN(funnelThreaded);
		RUN(funnelHybridThreaded);
		RUN(funnelFullHybridThreaded);
		RUN(mergeStackThreaded);
		RUN(mergeFifoThreaded);
	}
}

}

int main() {
	vector<size_t> sizes;
	for (double size(TEST_SIZE); size >= 1.0; size /= 1.5)
		sizes.push_back(size);
	for (vector<size_t>::const_reverse_iterator s(sizes.rbegin()); s != sizes.rend(); s ++) {
		doTests<Disk<DiskCache<65536, 8192> >, BigItem<200> >(*s, false, false);
	}
	return 0;
}
