#ifndef MEMORY_H
#define MEMORY_H

#include <cstdlib>

namespace Memory {

class Core {
public:
	static const char *name() { return "core"; }
	static size_t blocksize() { return PAGE_SIZE; }
	static bool threadSafe() { return allowThreads; }
	static bool allowThreads;
};

template<class Cache> class Disk {
public:
	static const char *name() { return "disk"; }
	static size_t blocksize() { return Cache::blocksize(); }
	static bool threadSafe() { return false; }
	static void resize(size_t size) { Cache::resize(size); }
	static void restoreSize() { Cache::restoreSize(); }
};

template<size_t pageSize, size_t pageCount, class BaseType, size_t logInacurracy, class Policy> class LogCache;

template<size_t pageSize, size_t pageCount, class BaseType, size_t logInaccuracy, class Policy> class Disk<LogCache<pageSize, pageCount, BaseType, logInaccuracy, Policy> > {
public:
	static const char *name() { return "logged-disk"; }
	static size_t blocksize() { return pageSize; }
	static bool threadSafe() { return false; }
};

}

#endif
