#ifndef SORT_COMMON_H
#define SORT_COMMON_H

#include <memory/pointer.h>
#include <memory/mapping.h>
#include <util/input_generator.h>
#include <util/stopwatch.h>

#include "util/assert.h"
#include <cstdio>
#include <typeinfo>
#include <cstring>

namespace Algorithm {
namespace Sort {
namespace Common {

template<class Storage, class Type> void bubble(Memory::Pointer<Storage, Type> array, size_t size) {
	for (size_t i(0); i < size; ++ i)
		for (size_t j(0); j < size - i - 1; ++ j)
			if (array[j] > array[j + 1]) {
				Type tmp(array[j]);
				array[j] = array[j + 1];
				array[j + 1] = tmp;
			}
}

template<class Array> void check(Array array, size_t size) {
	bool ok(true);
	for (size_t i(1); i < size; ++ i)
		if (array[i - 1] > array[i])
			ok = false;
	ASSERT_EXPL(ok, "Not sorted");
}

}

}
}

#endif
