#include "funnel.h"

namespace Algorithm {
namespace Sort {
namespace Funnel {

Split::Split(double count_):
	count(round(count_))
{
	while (count_ >= 1.5)
		mergeSizes.push_back(round(count_ = sqrt(count_)));
	mergeSizes.push_back(0);
}

void buildSplitHierarchy(std::vector<Split> &hierarchy, size_t size) {
	double splitSize(size);
	while (splitSize >= 1.5) {
		hierarchy.push_back(Split(splitSize = pow(splitSize, 1.0 / 3.0)));
		splitSize *= splitSize;
	}
}

}
}
}
