#ifndef SORT_HEAP_H
#define SORT_HEAP_H

#include <memory/pointer.h>

namespace Algorithm {
namespace Sort {
namespace Heap {

// Left son, conversion because of a heap starting at 0
// I could think about it and get an explicit formulae, but the compiler can handle it
size_t son(size_t parent) {
	parent ++;
	parent *= 2;
	return parent - 1;
}

template<class Storage, class T> void bubbleDown(Memory::Pointer<Storage, T> base, size_t pos, size_t size) {
	T item(base[pos]);
	size_t better(pos);
	do {
		pos = better;
		if (son(pos) + 1 < size)
			better = base[son(pos)] > base[son(pos) + 1] ? son(pos) : son(pos) + 1;
		else if (son(pos) < size)
			better = son(pos);
		if (item >= base[better])
			better = pos;
		base[pos] = base[better];
	} while (better != pos);
	base[pos] = item;
}

}

template<class Storage, class T> void heap(Memory::Pointer<Storage, T> input, size_t size) {
	using namespace Heap;
	for (size_t i(size); i --; )
		bubbleDown(input, i, size);
	for (size_t i(size); i --; ) {
		T tmp(*input);
		input[0] = input[i];
		input[i] = tmp;
		bubbleDown(input, 0, i);
	}
}

}
}

#endif
