#ifndef SORT_H
#define SORT_H

#include "qsort.h"
#include <util/stack.h>

namespace Algorithm {
namespace Sort {

template<class Storage, class Type, class Stack = Util::Stack<Storage, QSort::Range> > void sort(Memory::Pointer<Storage, Type> array, size_t length, Stack *stack = NULL) {
	if (stack) {
		Util::SharedStack<Storage, QSort::Range> qstack(*stack);
		if (Storage::threadSafe())
			QSort::qsort(array, length, THREAD_COUNT * THREAD_COUNT, qstack);
		else
			QSort::qsort(array, length, 1, qstack);
	} else {
		if (Storage::threadSafe())
			qsortThreaded(array, length);
		else
			qsort(array, length);
	}
}

}
}

#endif
