#ifndef TEST_REGISTER_H
#define TEST_REGISTER_H

namespace Test {

class Registrar;

class Registered {
	public:
		Registered();
		virtual void run() = 0;
	private:
		friend class Registrar;
		Registered *next;
};

class Registrar {
	public:
		Registrar(Registered *registered);
	private:
		friend void run();
		static void run_all();
		static Registered *head;
};

#define TEST_REGISTER(NAME) \
class NAME : public Test::Registered { \
	public: \
		virtual void run(); \
};\
\
static Test::Registrar NAME##testvar(new NAME); \
\
void NAME::run() 

}

#endif
