#include "assert.h"

#include <cstdio>
#include <cerrno>
#include <cstring>
#include <sys/types.h>
#include <unistd.h>

namespace Util {

void assertFail(const char *file, size_t lineNum, const char *function, const char *condition, const char *explanation) {
	if (!explanation) {
		fprintf(stderr, "%s:%zd:%s Assert %s failed (last errno: %d/%s)\n", file, lineNum, function, condition, errno, strerror(errno));
	} else {
		fprintf(stderr, "%s:%zd:%s %s(%s) (last errno: %d/%s)\n", file, lineNum, function, explanation, condition, errno, strerror(errno));
	}
	fflush(stdout);
	fflush(stderr);
	char *gdbcmd = getenv("GDB_CMD");
	if (gdbcmd) {
		char output[strlen(gdbcmd) + 100];
		sprintf(output, "%s %i", gdbcmd, (int) getpid());
		if (system(output) == -1)
			abort(); // The check is mostly to disable warning
	} else
		abort();
}

};
