#ifndef UTIL_ASSERT_H
#define UTIL_ASSERT_H

#include <cstdlib>

namespace Util {

void assertFail(const char *file, size_t lineNum, const char *function, const char *condition, const char *explanation);

};

#define ASSERT(CONDITION) do { if (!(CONDITION)) Util::assertFail(__FILE__, __LINE__, __FUNCTION__, #CONDITION, NULL); } while (0)
#define ASSERT_EXPL(CONDITION, EXPLANATION) do { if (!(CONDITION)) Util::assertFail(__FILE__, __LINE__, __FUNCTION__, #CONDITION, EXPLANATION); } while (0)

#endif
