#ifndef UTIL_BIGITEM_H
#define UTIL_BIGITEM_H

#include "input_generator.h"

namespace Util {

template<int size, class KeyType = int> struct BigItem {
	KeyType key;
	char stuffing[size - sizeof(KeyType)];
	bool operator <(const BigItem<size, KeyType> &other) const { return key < other.key; }
	bool operator >(const BigItem<size, KeyType> &other) const { return key > other.key; }
	bool operator ==(const BigItem<size, KeyType> &other) const { return key == other.key; }
	bool operator >=(const BigItem<size, KeyType> &other) const { return key >= other.key; }
	bool operator <=(const BigItem<size, KeyType> &other) const { return key <= other.key; }
	void random() {
		Generator::random(key);
	}
};

}

#endif
