#ifndef UTIL_QUEUE_H
#define UTIL_QUEUE_H

#include <memory/mapping.h>
#include <memory/pointer.h>

namespace Util {

template<class Storage, class Type> class Queue {
private:
	Memory::Mapping<Storage> mapping;
	Memory::Pointer<Storage, Type> data;
	size_t head, tail;
public:
	Queue(size_t size) :
		mapping(size * sizeof(Type), "Queue"),
		data(mapping),
		head(0),
		tail(0)
	{ }
	void push(const Type &t) {
		data[tail ++] = t;
	}
	Type &pop() {
		return data[head ++];
	}
	Type &top() {
		return data[head];
	}
	bool empty() { return head == tail; }
	void reset() {
		head = tail = 0;
	}
};

}

#endif
