#include "stopwatch.h"
#include "assert.h"

#include <cstdio>
#include <sys/time.h>

namespace Util {

namespace {

unsigned long long now() {
	struct timeval tv;
	int result(gettimeofday(&tv, NULL));
	ASSERT(!result);
	return 1000000 * tv.tv_sec + tv.tv_usec;
}

}

Stopwatch::Stopwatch(const char *algname_, const char *testname_, const char *storage_, const char *type_, size_t size_) :
	algname(algname_),
	testname(testname_),
	storage(storage_),
	type(type_),
	size(size_)
{ }

void Stopwatch::start() {
	printf("START:\t%s/%s\t%s\t%s\t%zu\n", algname, testname, storage, type, size);
	fflush(stdout);
	time = clock();
	rtime = now();
}

void Stopwatch::stop() {
	clock_t nowp(clock());
	unsigned long long nowr(now());
	// FIXME: Wrap around
	printf("STOP:\t%lf\t%lf\n", double(nowp - time) / CLOCKS_PER_SEC, double(nowr - rtime) / 1000000);
	fflush(stdout);
}

}
